HDU 5381(The sum of gcd-莫队算法解决区间段gcd的和)

The sum of gcd

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)

Total Submission(s): 784    Accepted Submission(s): 335

Problem Description

You have an array A,the
length of A
is n

Let f(l,r)=∑ri=lrj=igcd(ai,ai+1....aj)

Input

There are multiple test cases. The first line of input contains an integer T, indicating the number of test cases. For each test case:

First line has one integers n

Second line has n
integers Ai

Third line has one integers Q,the
number of questions

Next there are Q lines,each line has two integers l,r

1≤T≤3

1≤n,Q≤104

1≤ai≤109

1≤l<r≤n

Output

For each question,you need to print
f(l,r)

Sample Input

2
5
1 2 3 4 5
3
1 3
2 3
1 4
4
4 2 6 9
3
1 3
2 4
2 3

Sample Output

9
6
16
18
23
10

Author

SXYZ

Source

2015 Multi-University Training Contest 8

Recommend

wange2014   |   We have carefully selected several similar problems for you:  5421 5420 5419 5418 5417

预处理一段的gcd

我们发现一段的gcd是一样的

1 2 3 6 6 6 12

1 1 3 6 6 6 12 //从12开始向左的gcd

显然最多有logN段,接下来用莫队算法+杨氏转移

O(nlogn+nsqrt(n)logn)=O(n^1.5*logn)

#include<bits/stdc++.h>
using namespace std;
#define For(i,n) for(int i=1;i<=n;i++)
#define Fork(i,k,n) for(int i=k;i<=n;i++)
#define Rep(i,n) for(int i=0;i<n;i++)
#define ForD(i,n) for(int i=n;i;i--)
#define ForkD(i,k,n) for(int i=n;i>=k;i--)
#define RepD(i,n) for(int i=n;i>=0;i--)
#define Forp(x) for(int p=pre[x];p;p=next[p])
#define Forpiter(x) for(int &p=iter[x];p;p=next[p])
#define Lson (x<<1)
#define Rson ((x<<1)+1)
#define MEM(a) memset(a,0,sizeof(a));
#define MEMI(a) memset(a,127,sizeof(a));
#define MEMi(a) memset(a,128,sizeof(a));
#define INF (2139062143)
#define F (100000007)
#define MAXN (10000+10)
typedef long long ll;
ll mul(ll a,ll b){return (a*b)%F;}
ll add(ll a,ll b){return (a+b)%F;}
ll sub(ll a,ll b){return (a-b+llabs(a-b)/F*F+F)%F;}
void upd(ll &a,ll b){a=(a%F+b%F)%F;}
int n,a[MAXN],Q;
struct seg {
	int l,r,i;
	friend bool operator<(seg a,seg b){ return (int)((a.l)/sqrt(n))^(int)((b.l)/sqrt(n))?(int)((a.l)/sqrt(n))<(int)((b.l)/sqrt(n)):a.r<b.r;
	}
}comm[MAXN];
ll ans[MAXN];

ll gcd(ll a,ll b){if (b==0) return a; return gcd(b,a%b);}

int h[MAXN][100]={0};
ll val[MAXN][100]={0};
void init(int h[][100],ll  val[][100])
{
	MEM(val) MEM(h)
	For(i,n) h[i][0]=0;
	h[1][0]=1; h[1][1]=1; val[1][1]=a[1];
	Fork(i,2,n) {
		int &k=h[i][0];
		val[i][++k]=a[i];h[i][k]=i;
		For(j,h[i-1][0]) {
			ll p=gcd(val[i][k],val[i-1][j]);
			if (p!=val[i][k])
				val[i][++k]=p;
			h[i][k]=h[i-1][j];
		}
	}
}

int h2[MAXN][100]={0};
ll val2[MAXN][100]={0};
void init2(int h[][100],ll  val[][100])
{
	MEM(val) MEM(h)
	For(i,n) h[i][0]=0;
	h[n][0]=1; h[n][1]=n; val[n][1]=a[n];
	ForD(i,n-1) {
		int &k=h[i][0];
		val[i][++k]=a[i];h[i][k]=i;
		For(j,h[i+1][0]) {
			ll p=gcd(val[i][k],val[i+1][j]);
			if (p!=val[i][k])
				val[i][++k]=p;
			h[i][k]=h[i+1][j];
		}
	}
}

ll modify(){return 0;
}
ll modify(int l,int r,int f)
{
	ll ret=0;
	if (f==0) {  //left
		int fro=l;
		For(j,h2[l][0]) {
			int last=min(h2[l][j],r);
			if (fro<=last) ret+=val2[l][j]*(last-fro+1);
			fro=last+1;
			if (fro>r) break;
		}
	} else {
		int last=r;
		For(j,h[r][0]) {
			int fro=max(h[r][j],l);
			if (fro<=last) ret+=val[r][j]*(last-fro+1);
			last=fro-1;
			if (fro<l) break;
		}

	}
	return ret;

}

int main()
{
//	freopen("B.in","r",stdin);

	int T; cin>>T;
	while(T--) {
		cin>>n;
		For(i,n) scanf("%d",&a[i]);
		init(h,val);init2(h2,val2);

		cin>>Q;
		MEM(ans)
		For(i,Q)
		{
			 scanf("%d%d",&comm[i].l,&comm[i].r),comm[i].i=i;
		}
		sort(comm+1,comm+1+Q);

		int nowl=1,nowr=1;
		ll nowans=a[1];
		For(i,Q)
		{
			while (nowl<comm[i].l) nowans-=modify(nowl,nowr,0),nowl++;
			while (nowl>comm[i].l) nowans+=modify(nowl-1,nowr,0),nowl--;
			while (comm[i].r<nowr) nowans-=modify(nowl,nowr,1),nowr--;
			while (comm[i].r>nowr) nowans+=modify(nowl,nowr+1,1),nowr++;

			ans[comm[i].i]=nowans;
		}

		For(i,Q) printf("%I64d\n",ans[i]);
	} 	

	return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-14 06:07:43

HDU 5381(The sum of gcd-莫队算法解决区间段gcd的和)的相关文章

hdu5381 The sum of gcd]莫队算法

题意:http://acm.hdu.edu.cn/showproblem.php?pid=5381 思路:这个题属于没有修改的区间查询问题,可以用莫队算法来做.首先预处理出每个点以它为起点向左和向右连续一段的gcd发生变化的每个位置,不难发现对每个点A[i],这样的位置最多logA[i]个,这可以利用ST表用nlognlogA[i]的时间预处理,然后用二分+RMQ在nlogn的时间内得到.然后就是区间变化为1时的转移了,不难发现区间变化为1时,变化的答案仅仅是以变化的那一个点作为左端点或右端点的

HDU 5145 NPY and girls(莫队算法+乘法逆元)

[题目链接] http://acm.hdu.edu.cn/showproblem.php?pid=5145 [题目大意] 给出一个数列,每次求一个区间数字的非重排列数量.答案对1e9+7取模. [题解] 我们发现每次往里加入一个新的数字或者减去一个新的数字,前后的排列数目是可以通过乘除转移的,所以自然想到用莫队算法处理.因为答案要求取模,所以在用除法的时候要计算逆元. [代码] #include <cstdio> #include <algorithm> #include <

HDOJ 5381 The sum of gcd 莫队算法

大神题解: http://blog.csdn.net/u014800748/article/details/47680899 The sum of gcd Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 526    Accepted Submission(s): 226 Problem Description You have an

HDU 5381 The sum of gcd (2015年多校比赛第8场)

1.题目描述:点击打开链接 2.解题思路:本题利用莫队算法解决.由于是第一次学习这个算法,因此研究了比较长的一段时间才弄懂.首先,莫队算法解决的问题是无修改的离线区间查询问题.该算法实际上是由曼哈顿距离最小生成树演变来的,由于要处理m个区间,可以将这m个区间看做二维平面上的点,那么处理这m个区间就等价于让这m点连通,且总的转移代价最小.这其实就是一个曼哈顿距离最小生成树问题. 经典的曼哈顿距离最小生成树的时间复杂度是O(NlogN),莫队算法的时间复杂度是O(N^1.5).不过本题还有一个地方,

BZOJ 3289:Mato的文件管理(莫队算法+树状数组)

http://www.lydsy.com/JudgeOnline/problem.php?id=3289 题意:…… 思路:求交换次数即求逆序对数.确定了这个之后,先离散化数组.然后在后面插入元素的话,就是在区间里面找比它大的元素数量,在前面插入元素的话,就是在区间里面找比它小的元素数量.删除操作类似.因为排序是从小到大排序,所以要找比它大的数量就是区间长度减去小于等于该元素的数量,所以是(R - L + 1 - sum(a[i])),要找比它小的数量就是(sum(a[i] - 1)).然后用莫

莫队算法 [国家集训队]小Z的袜子

题目链接   洛古   https://www.luogu.org/problemnew/show/P1494 大概说下自己的理解 先来概率的计算公式   ∑C(2,f(i))  /  C(2,r?l+1)   f(i)是区间每种颜色袜子的数目 最后推出来的式子是 ∑f(i)*f(i)-(r?l+1)/ C(2,r?l+1)  (我也不知道怎么推的.......别人给的); 单纯的暴力就不说了  o(n*n*n); 说下和  o(n*n) 的; 莫队是 o(n*sqrt(n)); o(n*n)的

「知识学习&amp;日常训练」莫队算法(一)(Codeforce Round #340 Div.2 E)

题意 已知一个长度为\(n\)的整数数列\(a[1],a[2],-,a[n]\),给定查询参数\(l,r\),问\([l,r]\)内,有多少连续子段满足异或和等于\(k\). 也就是说,对于所有的\(x,y (l\le x\le y\le r)\),能够满足\(a[x]\oplus a[x+1]\oplus ...\oplus a[y]=k\)的\((x,y)\)有多少组. 分析 对于这种离线区间的查询问题(不涉及对区间的更改),我们可以使用莫队算法解决.这类问题是什么类型?对于序列上的区间询问

(预处理+莫队算法)HDU - 5381 The sum of gcd

题意: 一个长度为n的数列,m次查询L到R之间所有连续子序列的gcd之和. 分析: 很明显的莫队算法. 很明显发现了gcd是单调递减的,并且最多存在32个的性质. 想了很久,脑补了许多种方法来拉伸L和R,但是都有漏洞. 实际上,这道题还是比较复杂的.. 在思考的过程中,我没有充分利用gcd的递减性质. 这题其实这题有共通之处,至少在我的做法上是这样的. 可以发现,在R向右拉伸的过程中,增加的和只是从L到R+1中的每一个后缀的和. 向左则为减,L的移动同理. 那么我们只要提前预处理每个位置的前缀所

hdu 5381 The sum of gcd(线段树+gcd)

题目链接:hdu 5381 The sum of gcd 将查询离线处理,按照r排序,然后从左向右处理每个A[i],碰到查询时处理.用线段树维护,每个节点表示从[l,i]中以l为起始的区间gcd总和.所以每次修改时需要处理[1,i-1]与i的gcd值,但是因为gcd值是递减的,成log级,对于每个gcd值记录其区间即可.然后用线段树段修改,但是是修改一个等差数列. #include <cstdio> #include <cstring> #include <vector>